package com.test.comet;

import com.sun.enterprise.web.connector.grizzly.comet.CometContext;
import com.sun.enterprise.web.connector.grizzly.comet.CometEngine;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.logging.Logger;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author stanmina
 */
public class CometReader extends HttpServlet {

    private Logger log = Logger.getLogger(CometReader.class.getName());
    private String contextPath = null;
    //CometContext cometContext;

    @Override
    public void init(ServletConfig config) throws ServletException {
        log.info("init method cometReader");
        ServletContext context = config.getServletContext();
        contextPath = context.getContextPath() + "/long_polling";

        log.info("init method cometReader  context Path: " + contextPath);

        CometEngine engine = CometEngine.getEngine();
        CometContext cometContext = engine.register(contextPath);
        cometContext.setExpirationDelay(30 * 1000);
    }

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse response) throws ServletException, IOException {

        log.info("doGet method cometReader");

        MyCometHandler handler = new MyCometHandler();
        handler.attach(response);

        CometEngine engine = CometEngine.getEngine();
        CometContext cometContext = engine.getCometContext(contextPath);

        int cometHandlerId = cometContext.addCometHandler(handler);
        
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
        String msg = req.getParameter("msg");
        log.info("doPost method cometReader message: " + msg);
        
        PrintWriter writer = res.getWriter();
        writer.write("success");
        writer.flush();
    }
}